//+------------------------------------------------------------------+
//|                                                       emabuy.mq5 |
//|                                  Copyright 2023, MetaQuotes Ltd. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2023, MetaQuotes Ltd."
#property link      "https://www.mql5.com"
#property version   "1.00"

#include<Trade\Trade.mqh>

CTrade trade;

// Define input parameters
input double LotSize = 0.1;    // Lot size
input double StopLoss = 300;    // Stop loss in points
input double TakeProfit = 500;  // Take profit in points

// Define global variables

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
{
   // Calculate EMA25 value
   double ema25 = iMA(NULL,PERIOD_CURRENT, 25, 0, MODE_EMA, PRICE_CLOSE);
   double Bid = NormalizeDouble(SymbolInfoDouble(_Symbol, SYMBOL_BID),_Digits);
   double Ask = NormalizeDouble(SymbolInfoDouble(_Symbol, SYMBOL_ASK),_Digits);
         
   //--- prepare a request 
   MqlTradeRequest request={}; 
   request.action=TRADE_ACTION_DEAL;         // setting a pending order 
   request.symbol=_Symbol;                      // symbol 
   request.volume=LotSize;                          // volume in 0.1 lots 
   request.sl=StopLoss;                                // Stop Loss is not specified 
   request.tp=TakeProfit;                                // Take Profit is not specified      
   request.type=ORDER_TYPE_BUY;                // order type Buy
   request.price=Ask;                           // open price 
   
   MqlTradeResult result={}; 
   

    // Check if the current price is equal to EMA25
    if (MathAbs(Bid - ema25) < 0.01)
    {
    // Open a BUY position       
        int ticket=OrderSend(request,result);
              
    // Exit the EA
        ExpertRemove();
     }
}